Attribute VB_Name = "Module1"
Option Explicit

Type FIXED
    Fract As Integer
    Value As Integer
End Type

Type Pointapi
    x As Long
    y As Long
End Type

Type PointShort
    x As Integer
    y As Integer
End Type

Type PointSingle
    x As Single
    y As Single
End Type

Type POINTFX
    x As FIXED
    y As FIXED
End Type

Type TTPOLYCURVE

    wType As Integer ' Typ: polygon oder Bezier
    cpfx As Integer  ' Anzahl der folgenden Punkte
    apfx As POINTFX ' Array von Pointfixpunkten - eigentlich Unsinn, da
                    ' das Variabel sein mu

End Type

Private Type TTPOLYGONHEADER
    cb As Long          ' Summe der Bytes fr Header und Curves
    dwType As Long      ' immer TT_POLYGON_TYPE.
    pfxStart As POINTFX ' erster Punkt
End Type


Type GLYPHMETRICS

    gmBlackBoxX As Long ' ???
    gmBlackBoxY As Long
    gmptGlyphOrigin As Pointapi
    gmCellIncX As Integer
    gmCellIncY As Integer

End Type

Type MAT2
    eM11 As FIXED
    eM12 As FIXED
    eM21 As FIXED
    eM22 As FIXED
End Type

Declare Function GetGlyphOutline Lib "gdi32" Alias "GetGlyphOutlineA" _
                         (ByVal hdc As Long, ByVal uChar As Long, _
                         ByVal fuFormat As Long, lpgm As GLYPHMETRICS, _
                         ByVal cbBuffer As Long, lpBuffer As Any, lpmat2 As MAT2) _
                         As Long


 
Public Const GGO_BITMAP = 1
Public Const GGO_METRICS = 0
Public Const GGO_NATIVE = 2
 
 
Public Const TT_POLYGON_TYPE = 24
Public Const TT_PRIM_LINE = 1
Public Const TT_PRIM_QSPLINE = 2

Declare Sub CopyMemRef Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Declare Sub MemoryBmove Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest As Any, ByVal hpvSource As Any, ByVal cbCopy As Long)

Function PEEK(ByVal addr As Long) As Byte

    ' This will perform the same as the classical Peek function.
    ' I.e. it reads the binary value stored at a certain adress.
    ' Using: Call CopyMemRef(Peek, ByVal addr, 1) does the same a
    ' little faster, but the method below allows to check the
    ' result while debugging.

    Dim result As Byte
    Call CopyMemRef(result, ByVal addr, 1)
    PEEK = result

End Function

Function LPEEK(ByVal addr As Long) As Long

    Dim result As Long
    Call CopyMemRef(result, ByVal addr, 4)
    LPEEK = result

End Function
Sub Bezier4(maxp As Long, ByRef x() As Long, ByRef y() As Long, ByRef pt() As Pointapi)
  
  ' Vereinfachung der Berechnung, wenn die Standard-Bezierfunktion mit
  ' vier Punkten (maxp=3) bentigt wird. Hier sind die Binomialkoeffizienten
  ' vorberechnet, d.h. sie sind 1 bzw. 3.
  
  
  Dim i As Long    ' Zher fr Ankerpunkte
  Dim j As Long    ' Zhler fr Polygonpunkte
  Dim xi As Double ' Zwischenspeicher fr x und y
  Dim yi As Double
  Dim t As Double
  Dim a As Double
  Dim stp As Double ' Schrittweite
  Dim n As Long     ' Zahle der Polygonpunkte -1
  
   
  n = 20 * maxp ' Bei hheren Zahlen wird die Auflsung besser
                ' aber die Rechenzeit hher
  stp = 1 / n
  
  ReDim pt(n)
  j = -1
  
  For j = 0 To n  '
  
    t = j * stp
    
    a = (1 - t) ^ 3
    xi = a * x(0)
    yi = a * y(0)
    
    a = 3 * t * (1 - t) ^ 2
    xi = xi + a * x(1)
    yi = yi + a * y(1)
    
    a = 3 * t ^ 2 * (1 - t)
    xi = xi + a * x(2)
    yi = yi + a * y(2)
    
    a = t ^ 3
    xi = xi + a * x(3)
    yi = yi + a * y(3)
    
    pt(j).x = xi
    pt(j).y = yi
    
  Next j
 
  
End Sub
Function POINTFX_PEEK_a(ByVal addr As Long) As PointSingle

    Dim p As POINTFX
    Dim Ps As PointSingle
    Dim lg As Double
    Dim k As Long
    Dim x As Long
    Dim y As Long
    
    Call CopyMemRef(p, ByVal addr, 8)
    'p.x.Fract = -1
    DPOKE VarPtr(x), p.x.Fract
    If Abs(x) > 0 Then
        
        lg = Log(x) / Log(10#)
        If lg - Int(lg) > 0 Then
            k = Int(lg) + 1
            k = 5
        Else
            k = Int(lg)
        End If
    Else
        k = 0
    End If
    
    Ps.x = p.x.Value + x / (10 ^ k)
    
    DPOKE VarPtr(y), p.y.Fract
    
    If Abs(y) > 0 Then
            
        lg = Log(y) / Log(10#)
        If lg - Int(lg) > 0 Then
            k = Int(lg) + 1
            k = 5
        Else
            k = Int(lg)
        End If
    Else
        k = 0
    End If
    
    Ps.y = 0 + (y / (10 ^ k))
    'Ps.y = Sgn(p.y.Value) * Ps.y
    
    POINTFX_PEEK_a = Ps
    
End Function
Function POINTFX_PEEK(ByVal addr As Long) As PointSingle

    Dim p As Pointapi
    Dim Ps As PointSingle
    Dim lg As Double
    Dim k As Long
    Dim x As Long
    Dim y As Long
    
    Call CopyMemRef(p, ByVal addr, 8)
    
'    Ps.x = CDbl(p.x) / 65536#
'    Ps.y = CDbl(p.y) / 65536#
    Ps.x = (p.x) / 65536#
    Ps.y = (p.y) / 65536#
    POINTFX_PEEK = Ps
    
End Function
Sub DPOKE(ByVal dest As Long, ByVal pokeval As Integer)

    Dim addr As Long
    addr = VarPtr(pokeval)
    Call MemoryBmove(dest, ByVal addr, 2)
  
End Sub

Function DPEEK(ByVal addr As Long) As Integer

    Dim result As Integer
    Call CopyMemRef(result, ByVal addr, 2)
    DPEEK = result

End Function

Sub BMOVE(ByVal adrSource As Long, ByVal adrDest As Long, ByVal nBytes As Long)

    ' This sub is just used for clarity I.e. Binary Move source to destination
    ' and to get the same syntax as in older BASIC dialects.
    ' Also it also makes sure that adrSouce is alway passed by value and blocks
    ' the fatal error of passing negative numbers.
    
    If nBytes <= 0 Then
        If nBytes < 0 Then
            MsgBox "Attempt to use RTLMoveMemory with negative number of bytes - not performed!"
        End If
        Exit Sub ' negative values will cause a crash
    End If
    
    If adrDest = 0 Then
        MsgBox "Attempt to use RTLMoveMemory write to adress zero - not performed!"
        Exit Sub
    End If
    
    Call MemoryBmove(adrDest, ByVal adrSource, nBytes)

End Sub

Sub QsplineA(ByVal n As Long, ptIn() As PointSingle, ptOut() As PointSingle)

    Dim t As Double
    Dim tstep As Double
    Dim i As Long
    
    ReDim ptOut(0 To n)
    tstep = 1 / n
    For i = 0 To n
        ptOut(n).x = (ptIn(0).x - 2 * ptIn(1).x + ptIn(2).x) * t ^ 2 + (2 * ptIn(1).x - 2 * ptIn(0).x) * t + ptIn(0).x
        ptOut(n).x = (ptIn(0).y - 2 * ptIn(1).y + ptIn(2).y) * t ^ 2 + (2 * ptIn(1).y - 2 * ptIn(0).y) * t + ptIn(0).y
        t = t + tstep
    Next i

End Sub


Sub Qspline(ByVal n As Long, ByRef x() As Long, ByRef y() As Long, ByRef ptOut() As Pointapi)
    
    Dim i As Long
    Dim t As Double
    Dim tstep As Double
    ReDim ptOut(0 To n)
    
    tstep = 1 / (n)
    
    For i = 0 To n
    
        t = i * tstep
        ptOut(i).x = (x(0) - 2 * x(1) + x(2)) * t ^ 2 + (2 * x(1) - 2 * x(0)) * t ^ 1 + x(0)
        ptOut(i).y = (y(0) - 2 * y(1) + y(2)) * t ^ 2 + (2 * y(1) - 2 * y(0)) * t ^ 1 + y(0)
         
    Next i

End Sub

